Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim conString As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(conString)
            Dim query As String = "SELECT CustomerID, City, PostalCode FROM Customers"
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    gvCustomers.DataSource = dt
                    gvCustomers.DataBind()
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPaging(ByVal sender As Object, ByVal e As GridViewPageEventArgs)
        Me.GetSelectedRecord()
        gvCustomers.PageIndex = e.NewPageIndex
        Me.BindGrid()
        Me.SetSelectedRecord()
    End Sub

    Private Sub GetSelectedRecord()
        Dim selectedRow As GridViewRow = (From row In gvCustomers.Rows
                                          Where TryCast(row.FindControl("rbCustomer"), RadioButton).Checked = True
                                          Select row).FirstOrDefault()
        If selectedRow IsNot Nothing Then
            ViewState("SelctedCustomer") = gvCustomers.DataKeys(selectedRow.RowIndex).Values(0)
        End If
    End Sub

    Private Sub SetSelectedRecord()
        If ViewState("SelctedCustomer") IsNot Nothing Then
            Dim rbCustomer As RadioButton = (From row In gvCustomers.Rows
                                             Where gvCustomers.DataKeys(row.RowIndex).Values(0).ToString() = ViewState("SelctedCustomer").ToString()
                                             Select TryCast(row.FindControl("rbCustomer"), RadioButton)).FirstOrDefault()
            If rbCustomer IsNot Nothing Then
                rbCustomer.Checked = True
            End If
        End If
    End Sub
End Class
